- HTTP request
- Path parameters
- Query parameters
- Request body
- Response body
- Authorization Scopes
- IAM Permissions
Updates the specified regional BackendService resource with the data included in the request. There are several restrictions and guidelines to keep in mind when updating a backend service. Read Restrictions and Guidelines for more information.
HTTP request
PUT https://www.googleapis.com/compute/v1/projects/{project}/regions/{region}/backendServices/{resourceId}
The URL uses gRPC Transcoding syntax.
Path parameters
| Parameters | |
|---|---|
project |
Project ID for this request. |
region |
Name of the region scoping this request. |
resourceId |
Name of the BackendService resource to update. |
Query parameters
| Parameters | |
|---|---|
requestId |
An optional request ID to identify requests. Specify a unique request ID so that if you must retry your request, the server will know to ignore the request if it has already been completed. For example, consider a situation where you make an initial request and the request times out. If you make the request again with the same request ID, the server can check if original operation with the same request ID was received, and if so, will ignore the second request. This prevents clients from accidentally creating duplicate commitments. The request ID must be a valid UUID with the exception that zero UUID is not supported ( |
Request body
The request body contains data with the following structure:
| JSON representation | |
|---|---|
{ "id": string, "creationTimestamp": string, "name": string, "description": string, "selfLink": string, "backends": [ { "description": string, "group": string, "balancingMode": enum, "maxUtilization": number, "maxRate": number, "maxRatePerInstance": number, "maxRatePerEndpoint": number, "maxConnections": number, "maxConnectionsPerInstance": number, "maxConnectionsPerEndpoint": number, "capacityScaler": number } ], "healthChecks": [ string ], "timeoutSec": number, "port": number, "protocol": enum, "fingerprint": string, "portName": string, "enableCDN": boolean, "sessionAffinity": enum, "affinityCookieTtlSec": number, "region": string, "loadBalancingScheme": enum, "connectionDraining": { "drainingTimeoutSec": number }, "iap": { "enabled": boolean, "oauth2ClientId": string, "oauth2ClientSecret": string, "oauth2ClientSecretSha256": string }, "cdnPolicy": { "cacheKeyPolicy": , "signedUrlKeyNames": [ string ], "signedUrlCacheMaxAgeSec": string }, "customRequestHeaders": [ string ], "securityPolicy": string, "kind": string } |
|
| Fields | |
|---|---|
id |
[Output Only] The unique identifier for the resource. This identifier is defined by the server. |
creationTimestamp |
[Output Only] Creation timestamp in RFC3339 text format. |
name |
Name of the resource. Provided by the client when the resource is created. The name must be 1-63 characters long, and comply with RFC1035. Specifically, the name must be 1-63 characters long and match the regular expression |
description |
An optional description of this resource. Provide this property when you create the resource. |
selfLink |
[Output Only] Server-defined URL for the resource. |
backends[] |
The list of backends that serve this BackendService. |
backends[].description |
An optional description of this resource. Provide this property when you create the resource. |
backends[].group |
The fully-qualified URL of an instance group or network endpoint group (NEG) resource. The type of backend that a backend service supports depends on the backend service's
You must use the fully-qualified URL (starting with Authorization requires the following Google IAM permission on the specified resource
|
backends[].balancingMode |
Specifies the balancing mode for the backend. When choosing a balancing mode, you need to consider the
|
backends[].maxUtilization |
Defines the maximum average CPU utilization of a backend VM in an instance group. The valid range is This parameter can be used in conjunction with |
backends[].maxRate |
The max requests per second (RPS) of the group. Can be used with either This cannot be used for internal load balancing. |
backends[].maxRatePerInstance |
Defines a maximum target for requests per second (RPS) for a single VM in a backend instance group. This is multiplied by the number of instances in the instance group to implicitly calculate a target maximum rate for the whole instance group. If the backend's Not available if the backend's |
backends[].maxRatePerEndpoint |
Defines a maximum target for requests per second (RPS) for an endpoint of a NEG. This is multiplied by the number of endpoints in the NEG to implicitly calculate a target maximum rate for the NEG. If the backend's Not available if the backend's |
backends[].maxConnections |
Defines a maximum target for simultaneous connections for the entire backend (instance group or NEG). If the backend's Not available if the backend's |
backends[].maxConnectionsPerInstance |
Defines a maximum target for simultaneous connections for a single VM in a backend instance group. This is multiplied by the number of instances in the instance group to implicitly calculate a target maximum number of simultaneous connections for the whole instance group. If the backend's Not available if the backend's |
backends[].maxConnectionsPerEndpoint |
Defines a maximum target for simultaneous connections for an endpoint of a NEG. This is multiplied by the number of endpoints in the NEG to implicitly calculate a maximum number of target maximum simultaneous connections for the NEG. If the backend's Not available if the backend's |
backends[].capacityScaler |
A multiplier applied to the group's maximum servicing capacity (based on This cannot be used for internal load balancing. |
healthChecks[] |
The list of URLs to the HttpHealthCheck or HttpsHealthCheck resource for health checking this BackendService. Currently at most one health check can be specified, and a health check is required for Compute Engine backend services. A health check must not be specified for App Engine backend and Cloud Function backend. For internal load balancing, a URL to a HealthCheck resource must be specified instead. Authorization requires one or more of the following Google IAM permissions on the specified resource
|
timeoutSec |
The backend service timeout has a different meaning depending on the type of load balancer. For more information read, Backend service settings The default is 30 seconds. |
port |
Deprecated in favor of This cannot be used if the |
protocol |
The protocol this BackendService uses to communicate with backends. Possible values are HTTP, HTTPS, TCP, SSL, or UDP, depending on the chosen load balancer or Traffic Director configuration. Refer to the documentation for the load balancer or for Traffic director for more information. |
fingerprint |
Fingerprint of this resource. A hash of the contents stored in this object. This field is used in optimistic locking. This field will be ignored when inserting a BackendService. An up-to-date fingerprint must be provided in order to update the To see the latest fingerprint, make a A base64-encoded string. |
portName |
A named port on a backend instance group representing the port for communication to the backend VMs in that group. Required when the Must be omitted when the |
enableCDN |
If |
sessionAffinity |
Type of session affinity to use. The default is When the When the When the |
affinityCookieTtlSec |
If set to |
region |
[Output Only] URL of the region where the regional backend service resides. This field is not applicable to global backend services. You must specify this field as part of the HTTP request URL. It is not settable as a field in the request body. |
loadBalancingScheme |
Indicates whether the backend service will be used with internal or external load balancing. A backend service created for one type of load balancing cannot be used with the other. Possible values are |
connectionDraining |
|
connectionDraining.drainingTimeoutSec |
The amount of time in seconds to allow existing connections to persist while on unhealthy backend VMs. Only applicable if the |
iap |
|
iap.enabled |
|
iap.oauth2ClientId |
|
iap.oauth2ClientSecret |
|
iap.oauth2ClientSecretSha256 |
[Output Only] SHA256 hash value for the field oauth2ClientSecret above. |
cdnPolicy |
Cloud CDN configuration for this BackendService. |
cdnPolicy.cacheKeyPolicy |
The CacheKeyPolicy for this CdnPolicy. |
cdnPolicy.cacheKeyPolicy.includeProtocol |
If true, http and https requests will be cached separately. |
cdnPolicy.cacheKeyPolicy.includeHost |
If true, requests to different hosts will be cached separately. |
cdnPolicy.cacheKeyPolicy.includeQueryString |
If true, include query string parameters in the cache key according to queryStringWhitelist and queryStringBlacklist. If neither is set, the entire query string will be included. If false, the query string will be excluded from the cache key entirely. |
cdnPolicy.cacheKeyPolicy.queryStringWhitelist[] |
Names of query string parameters to include in cache keys. All other parameters will be excluded. Either specify queryStringWhitelist or queryStringBlacklist, not both. '&' and '=' will be percent encoded and not treated as delimiters. |
cdnPolicy.cacheKeyPolicy.queryStringBlacklist[] |
Names of query string parameters to exclude in cache keys. All other parameters will be included. Either specify queryStringWhitelist or queryStringBlacklist, not both. '&' and '=' will be percent encoded and not treated as delimiters. |
cdnPolicy.signedUrlKeyNames[] |
[Output Only] Names of the keys for signing request URLs. |
cdnPolicy.signedUrlCacheMaxAgeSec |
Maximum number of seconds the response to a signed URL request will be considered fresh. After this time period, the response will be revalidated before being served. Defaults to 1hr (3600s). When serving responses to signed URL requests, Cloud CDN will internally behave as though all responses from this backend had a |
customRequestHeaders[] |
Headers that the HTTP/S load balancer should add to proxied requests. |
securityPolicy |
[Output Only] The resource URL for the security policy associated with this backend service. |
kind |
[Output Only] Type of resource. Always |
Response body
If successful, the response body contains data with the following structure:
| JSON representation | |
|---|---|
{ "id": string, "creationTimestamp": string, "name": string, "zone": string, "clientOperationId": string, "operationType": string, "targetLink": string, "targetId": string, "status": enum, "statusMessage": string, "user": string, "progress": number, "insertTime": string, "startTime": string, "endTime": string, "error": { "errors": [ { "code": string, "location": string, "message": string } ] }, "warnings": [ { "code": enum, "message": string, "data": [ { "key": string, "value": string } ] } ], "httpErrorStatusCode": number, "httpErrorMessage": string, "selfLink": string, "region": string, "description": string, "kind": string } |
|
| Fields | |
|---|---|
id |
[Output Only] The unique identifier for the resource. This identifier is defined by the server. |
creationTimestamp |
[Deprecated] This field is deprecated. |
name |
[Output Only] Name of the resource. |
zone |
[Output Only] The URL of the zone where the operation resides. Only applicable when performing per-zone operations. |
clientOperationId |
[Output Only] The value of |
operationType |
[Output Only] The type of operation, such as |
targetLink |
[Output Only] The URL of the resource that the operation modifies. For operations related to creating a snapshot, this points to the persistent disk that the snapshot was created from. |
targetId |
[Output Only] The unique target ID, which identifies a specific incarnation of the target resource. |
status |
[Output Only] The status of the operation, which can be one of the following: |
statusMessage |
[Output Only] An optional textual description of the current status of the operation. |
user |
[Output Only] User who requested the operation, for example: |
progress |
[Output Only] An optional progress indicator that ranges from 0 to 100. There is no requirement that this be linear or support any granularity of operations. This should not be used to guess when the operation will be complete. This number should monotonically increase as the operation progresses. |
insertTime |
[Output Only] The time that this operation was requested. This value is in RFC3339 text format. |
startTime |
[Output Only] The time that this operation was started by the server. This value is in RFC3339 text format. |
endTime |
[Output Only] The time that this operation was completed. This value is in RFC3339 text format. |
error |
[Output Only] If errors are generated during processing of the operation, this field will be populated. |
error.errors[] |
[Output Only] The array of errors encountered while processing this operation. |
error.errors[].code |
[Output Only] The error type identifier for this error. |
error.errors[].location |
[Output Only] Indicates the field in the request that caused the error. This property is optional. |
error.errors[].message |
[Output Only] An optional, human-readable error message. |
warnings[] |
[Output Only] If warning messages are generated during processing of the operation, this field will be populated. |
warnings[].code |
[Output Only] A warning code, if applicable. For example, Compute Engine returns |
warnings[].message |
[Output Only] A human-readable description of the warning code. |
warnings[].data[] |
[Output Only] Metadata about this warning in "data": [ { "key": "scope", "value": "zones/us-east1-d" }
|
warnings[].data[].key |
[Output Only] A key that provides more detail on the warning being returned. For example, for warnings where there are no results in a list request for a particular zone, this key might be |
warnings[].data[].value |
[Output Only] A warning data value corresponding to the key. |
httpErrorStatusCode |
[Output Only] If the operation fails, this field contains the HTTP error status code that was returned. For example, a |
httpErrorMessage |
[Output Only] If the operation fails, this field contains the HTTP error message that was returned, such as |
selfLink |
[Output Only] Server-defined URL for the resource. |
region |
[Output Only] The URL of the region where the operation resides. Only applicable when performing regional operations. |
description |
[Output Only] A textual description of the operation, which is set when the operation is created. |
kind |
[Output Only] Type of the resource. Always |
Authorization Scopes
Requires one of the following OAuth scopes:
https://www.googleapis.com/auth/computehttps://www.googleapis.com/auth/cloud-platform
For more information, see the Authentication Overview.
IAM Permissions
In addition to any permissions specified on the fields above, authorization requires one or more of the following Google IAM permissions:
compute.regionBackendServices.update


